#!/usr/bin/env python3
import functools

from oslo_policy import policy

from tveapi.common import exceptions
ENFORCER = None


def setup_policy(conf):
    global ENFORCER
    
    ENFORCER = policy.Enforcer(conf)


def enforce(rule):

    def decorator(func):
        @functools.wraps(func)
        def handler(*args, **kwargs):
            ctx = args[1].env['tveapi.context']
            ENFORCER.enforce(rule, {}, ctx.to_dict(), do_raise=True,
                             exc=exceptions.AccessForbidden)
            return func(*args, **kwargs)
        return handler

    return decorator
