from oslo_log import log
import socket
import time
import os

LOG = log.getLogger(__name__)

def request_notifier(req, resp, resource, params):
    collectd_path = '/tmp/collectd_sock'
    
    try:
        with open('/config/collectd-hostname', 'r') as f:
            host = f.readline().strip()
    except:
        host=socket.gethostname()
    
    if os.path.exists(collectd_path):
        try:
            message = "REST API Request %s %s from %s " % (req.method,req.url,req.remote_addr)
            severity = 'WARNING'
            msg = "PUTNOTIF type=\"\" host={} severity={} time={} message=\"{}\"\n".format(
                host, severity, str(time.time()), message)
        except Exception as e:
            return
            pass
        
        cl = None
        try:
            cl = socket.socket(socket.AF_UNIX, socket.SOCK_STREAM)
            cl.connect(collectd_path)
            cl.sendall(msg.encode('utf-8'))
            cl.setblocking(0)
            ch = cl.recv(1)
            while ch != "\n":
                ch = cl.recv(1)
        except Exception as e:
            pass
        finally:
            if cl:
                cl.close()
        return
        

