#!/usr/bin/env python3
import json
import os
from collections import OrderedDict

import falcon
from oslo_log import log
from tveapi.common import resource as res
import sys
sys.path.insert(1, '/usr/lib/python3/dist-packages/tveapi/')

LOG = log.getLogger(__name__)

class PublicKey(res.BaseResource):
    def on_fail(self, resp, message):
        errmsg = OrderedDict()
        errmsg['404'] = ("{}".format(message))
        resp.body = errmsg
        resp.status = falcon.HTTP_404
        resp.data = json.dumps(errmsg, indent=4, separators=(',', ': ')).encode('utf8')
        resp.content_type = 'application/json'

    #curl -H "X-Auth-Token: $TOKEN" -H "Content-type:application/json" -k --insecure  -X GET https://10.3.69.58:7373/v1/wireguard/public-key
    def on_get(self, req, resp):
        public_key="Unknown"
        try:
            filename = '/etc/wg/public.key'
            if os.path.exists(filename):
                with open(filename, 'r') as f:
                    public_key = f.read().strip()
        except:
            pass
        resp.data = json.dumps({'public-key':'%s'% public_key} , indent=4, separators=(',', ': ')).encode('utf8')
        return

    #curl -H "X-Auth-Token: $TOKEN" -H "Content-type:application/json" -k --insecure  -X PUT https://10.3.69.58:7373/v1/wireguard/public-key 
    # -d '{"endpoint":"10.3.69.76", "public-key":"YhEbu4hWHfkj7mOJgUJGy3FPiNsI414jozd6JpDBaG0="}'
    def on_put(self, req, resp):
        endpoint = ""
        public_key = ""
        if req.content_length > 0:
            json_req = self.json_body(req)
            if 'endpoint' in json_req:
                endpoint = json_req['endpoint']
            if 'public-key' in json_req:
                public_key = json_req['public-key']
        if endpoint == "" or public_key == "":
            self.on_fail(resp, "Bad request")
            return
        try:
            if not os.path.exists('/etc/wg'):
                os.system('/usr/bin/sudo mkdir /etc/wg')
            if not os.path.exists('/etc/wg/{}' .format(endpoint)):
                os.system('/usr/bin/sudo mkdir /etc/wg/\"%s\"' % endpoint)
            filename = '/etc/wg/{}/public.key' .format(endpoint)
            os.system('/usr/bin/sudo bash -c "echo \"%s\"  > \"%s\""' %(public_key, filename))
        except Exception as e:
            LOG.error("fail exception CalledProcessError")
            self.on_fail(resp, e)
            return
        return


